package sample;

import java.util.List;

import org.jbpm.api.ProcessInstance;
import org.jbpm.api.task.Task;
import org.jbpm.test.JbpmTestCase;


public class ComplateTaskTest extends JbpmTestCase {

  String deploymentId;
  
  protected void setUp() throws Exception {
 
    super.setUp();
  
    deploymentId = repositoryService.createDeployment()
    .addResourceFromClasspath("sample/ComplateTaskTest.jpdl.xml")
    .deploy();
  }

  protected void tearDown() throws Exception {
    repositoryService.deleteDeploymentCascade(deploymentId);
    super.tearDown();
  }
  
  public void testAddSubTasks() {
    ProcessInstance pi = executionService.startProcessInstanceByKey("ComplateTaskTest");
    
    //find tasks by execution id
    Task task = taskService.createTaskQuery().processInstanceId(pi.getId()).uniqueResult();
    
    assertEquals("lizhi", task.getAssignee());
    
    Task subTask1 = taskService.newTask(task.getId());
    taskService.saveTask(subTask1);
    
    Task subTask2 = taskService.newTask(task.getId());
    taskService.saveTask(subTask2);
    
    
    List<Task> tasks = taskService.createTaskQuery().processInstanceId(pi.getId()).list();
    assertEquals(1, tasks.size());
    
    List<Task> subTasks=taskService.getSubTasks(tasks.get(0).getId());
    
    assertEquals(2, subTasks.size());
    
    taskService.completeTask(subTasks.get(0).getId());
    taskService.completeTask(subTasks.get(1).getId());
    
    taskService.completeTask(task.getId(),"to state1");
  }

}
